import React from "react";
import { Fragment, jsx, jsxs } from "react/jsx-runtime";
import { jsxDEV } from "react/jsx-dev-runtime";
import { fromLezer } from "hast-util-from-lezer";
import { toJsxRuntime } from "hast-util-to-jsx-runtime";
export const Parsers = React.createContext({});
export const Code = (props) => {
    const parsers = React.useContext(Parsers);
    const className = typeof props.className === "string"
        ? props.className
        : props.className?.(props.language);
    if (props.language === undefined || parsers[props.language] === undefined) {
        return React.createElement("code", { className: className }, props.source);
    }
    const parser = parsers[props.language];
    const tree = parser.parse(props.source);
    const root = fromLezer(props.source, tree);
    const content = toJsxRuntime(root, { Fragment, jsx, jsxs, jsxDEV });
    return React.createElement("code", { className: className }, content);
};
